#include <stdio.h>
#include <string>
#include <windows.h>
#include "../resource.h"
extern HINSTANCE g_hinst;
#  define NUMBER_OF(i_array) (sizeof(i_array) / sizeof((i_array)[0]))

//
class DialogPassphrase
{
  HWND m_hwnd;					// HWND of dialog box
  std::string m_prompt;				// prompt
  std::string m_passPhrase;			// result
  std::string m_user;
  std::string m_userout;
  
private:
  static BOOL CALLBACK dlgProc(HWND i_hwnd, UINT i_message,
			       WPARAM i_wParam, LPARAM i_lParam)
  {
    DialogPassphrase *This =
      reinterpret_cast<DialogPassphrase *>(
	GetWindowLong(i_hwnd, GWL_USERDATA));
    if (!This)
      switch (i_message)
      {
	case WM_INITDIALOG:
	  This = reinterpret_cast<DialogPassphrase *>(i_lParam);
	  SetWindowLong(i_hwnd, GWL_USERDATA, i_lParam);
	  This->initialize(i_hwnd);
	  return This->wmInitDialog(reinterpret_cast<HWND>(i_wParam));
      }
    else
      switch (i_message)
      {
	case WM_CLOSE:
	  return This->wmClose();
	case WM_COMMAND:
	  return This->wmCommand(HIWORD(i_wParam), LOWORD(i_wParam),
				 reinterpret_cast<HWND>(i_lParam));
      }
    return FALSE;
  }

  //
  void initialize(HWND i_hwnd)
  {
    m_hwnd = i_hwnd;
  }
  
  // WM_INITDIALOG
  BOOL wmInitDialog(HWND /* i_focus */)
  {
    SetWindowText(GetDlgItem(m_hwnd, IDC_PROMPT), m_prompt.c_str());
	SetWindowText(GetDlgItem(m_hwnd, IDC_USER), m_user.c_str());
//    setSmallIcon(m_hwnd, IDI_ASK_PASS);
//    setBigIcon(m_hwnd, IDI_ASK_PASS);
    return TRUE;
  }

  // WM_CLOSE
  BOOL wmClose()
  {
    EndDialog(m_hwnd, 0);
    return TRUE;
  }

  // WM_COMMAND
  BOOL wmCommand(int /* i_notifyCode */, int i_id, HWND /* i_hwndControl */)
  {
    switch (i_id)
    {
      case IDOK:
      {
	TCHAR buf[1024];
	GetWindowText(GetDlgItem(m_hwnd, IDC_PASSPHRASE), buf, NUMBER_OF(buf));
	m_passPhrase = buf;

	TCHAR buf2[1024];
	GetWindowText(GetDlgItem(m_hwnd, IDC_USER), buf2, NUMBER_OF(buf2));
	m_userout = buf2;

	EndDialog(m_hwnd, 1);
	return TRUE;
      }
      case IDCANCEL:
      {
	EndDialog(m_hwnd, 0);
	return TRUE;
      }
    }
    return FALSE;
  }

public:
  //
  DialogPassphrase(const std::string &i_prompt,const std::string &i_user)
    : m_hwnd(NULL),
      m_prompt(i_prompt),
	  m_user(i_user)
  {
  }

  //
  INT_PTR dialogBox(HWND i_hwndParent)
  {
    return DialogBoxParam(g_hinst, MAKEINTRESOURCE(IDD_ASK_PASS),i_hwndParent, dlgProc,reinterpret_cast<LPARAM>(this));
  }
  
  //
  const std::string &getPassPhrase() const
  {
    return m_passPhrase;
  }

  const std::string &getUser() const
  {
    return m_userout;
  }
};

// main
extern "C" 
int askpassbox(char *input, char *inuser, char *output, char *outuser)
{
 // g_hInst2 = GetModuleHandle(NULL);
  
  DialogPassphrase dp(input,inuser);
  if (dp.dialogBox(NULL))
  {
    printf("%s\n", dp.getPassPhrase().c_str());
    strcpy(output,dp.getPassPhrase().c_str());

	printf("%s\n", dp.getUser().c_str());
    strcpy(outuser,dp.getUser().c_str());
  }
  else
  {
    printf("\n");
    strcpy(output,"");
  }

  return 0;
}
